/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.FormaPago;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderFormaPago;
import java.util.HashMap;
import java.util.Map;
import org.zkoss.zk.ui.Component;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Listheader;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

/**
 * 
 * @author Administrador
 */
@Controller("busquedaFormaPagoController")
@Scope("prototype")
public class BusquedaFormaPagoController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<FormaPago> plwFormaPago;
	private MyListbox formaPagoList;
	private Paging pagingFormaPago;
	private Textbox txtNome;
	private Textbox txtEquivalencia;
	private Row rowEquivalencia;
	private Listheader headerEquivalencia;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		formaPagoList.setItemRenderer(new RenderFormaPago());
		formaPagoList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				FormaPago c = (FormaPago) formaPagoList.getSelected();
				verFormaPago(c);
			}
		});

		refreshLista();

		if (!ApplicationProperties.getInstance().mostrarEquivalencia()) {
			rowEquivalencia.setVisible(Boolean.FALSE);
			headerEquivalencia.setVisible(Boolean.FALSE);
		}

		txtNome.focus();
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void verFormaPago(FormaPago f) {
		if (f == null) {
			return;
		}

		Map args = new HashMap();
		args.put("formaPago", f);
		args.put("busquedaFormaPagoController", this);
		args.put("formaPagoList", formaPagoList);

		openWindow("/gui/catalogos/editarFormaPago.zul",
				Labels.getLabel("editarFormaPagoController.window.title"), args, MODAL);
	}

	public void refreshLista() {
		HibernateSearchObject<FormaPago> formaPagoBusqueda =
				new HibernateSearchObject<FormaPago>(FormaPago.class,
						pagingFormaPago.getPageSize());

		formaPagoBusqueda.addFilterLike("descpago", "%" + txtNome.getText().trim().concat("%"));

		if (!txtEquivalencia.getText().isEmpty()) {
			formaPagoBusqueda.addFilterLike("equivalenciaId", txtEquivalencia.getText().trim().concat("%"));
		}

		formaPagoBusqueda.addFilterNotEqual("formapagoId", -1);
		formaPagoBusqueda.addSortAsc("descpago");
		formaPagoBusqueda.addFilterEqual("activo", Boolean.TRUE);

		plwFormaPago.init(formaPagoBusqueda, formaPagoList, pagingFormaPago);

		if (formaPagoList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaFormaPagoController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verFormaPago(new FormaPago());
	}
}
